package com.doumi.jianzhi.im.message.messagecontent

import android.os.Parcel
import android.os.Parcelable
import com.doumi.jianzhi.im.message.model.JobConsulorVipModel
import com.google.gson.Gson
import io.rong.common.ParcelUtils
import io.rong.imlib.MessageTag
import io.rong.imlib.model.MessageContent

/**
 * @Description:求职顾问会员推送卡片消息
 * @Author: huangyonghuang
 * @CreateDate: 2019-11-26 11:36
 * @Email:huangyonghuang@doumi.com
 */

@MessageTag(value = "doumi:VipMsg", flag = MessageTag.ISCOUNTED or MessageTag.ISPERSISTED)
class CounselorVipMsg : MessageContent {

    private val mGson = Gson()

    private var jobConsulorVipModel: JobConsulorVipModel


    constructor (data: ByteArray?) : super(data) {
        val jsonStr = String(data ?: "".toByteArray(), charset("UTF-8"))
        jobConsulorVipModel = mGson.fromJson(jsonStr, JobConsulorVipModel::class.java)
    }


    constructor (parcel: Parcel) {
        val contentJson = ParcelUtils.readFromParcel(parcel)
        jobConsulorVipModel = mGson.fromJson(contentJson, JobConsulorVipModel::class.java)
    }


    fun getContent() = jobConsulorVipModel

    override fun writeToParcel(dest: Parcel?, p1: Int) = ParcelUtils.writeToParcel(dest, mGson.toJson(jobConsulorVipModel))

    override fun encode(): ByteArray = mGson.toJson(jobConsulorVipModel).toByteArray(charset("UTF-8"))


    override fun describeContents(): Int = 0

    companion object CREATOR : Parcelable.Creator<CounselorVipMsg> {
        override fun createFromParcel(parcel: Parcel): CounselorVipMsg {
            return CounselorVipMsg(parcel)
        }

        override fun newArray(size: Int): Array<CounselorVipMsg?> {
            return arrayOfNulls(size)
        }
    }


}