package com.doumi.jianzhi.im.message.provider

import android.content.Context
import android.text.Spannable
import android.text.SpannableString
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.doumi.jianzhi.R
import com.doumi.jianzhi.im.message.messagecontent.CounselorVipMsg
import com.doumi.jianzhi.logcollect.LogHelper
import com.doumi.jianzhi.utils.JianzhiUrdUtil.DispJianZhiMemberCenter
import com.kercer.kerkeeplus.urd.uridispatcher.impl.KCUriDispatcher
import io.rong.imkit.model.ProviderTag
import io.rong.imkit.model.UIMessage
import io.rong.imkit.widget.provider.IContainerItemProvider.MessageProvider

/**
 * @Description:求职顾问中vip推送卡片
 * @Author: huangyonghuang
 * @CreateDate: 2019-11-26 14:13
 * @Email:huangyonghuang@doumi.com
 */
@ProviderTag(messageContent = CounselorVipMsg::class, showSummaryWithName = false, showProgress = false, centerInHorizontal = true, showPortrait = false)
class CounselorVipItemProvider : MessageProvider<CounselorVipMsg>() {

    var mContext: Context? = null


    override fun newView(context: Context?, group: ViewGroup?): View {

        this.mContext = context

        val view = LayoutInflater.from(context).inflate(R.layout.im_consolur_vip_provider_layout, group, false)
        view.tag = ViewHolder(view)
        return view
    }

    override fun bindView(view: View?, position: Int, content: CounselorVipMsg?, message: UIMessage?) {

        val viewHolder = view?.tag as ViewHolder

        val model = content?.getContent()

        model?.let {
            viewHolder.tvContent.text = it.title
            viewHolder.tvContentHint.text = it.describe
            viewHolder.tvAcquire.setOnClickListener {

                KCUriDispatcher.dispatcher(DispJianZhiMemberCenter)
                showCardEV()
            }
        }

    }

    override fun getContentSummary(data: CounselorVipMsg?): Spannable {
        return SpannableString(data?.getContent()?.title)
    }

    override fun onItemClick(view: View?, position: Int, content: CounselorVipMsg?, message: UIMessage?) {
    }

    override fun onItemLongClick(view: View?, position: Int, content: CounselorVipMsg?, message: UIMessage?) {
    }


    class ViewHolder(var rootView: View) {
        var tvContent: TextView = rootView.findViewById(R.id.tv_content)
        var tvContentHint: TextView = rootView.findViewById(R.id.tv_content_hint)
        var tvAcquire: TextView = rootView.findViewById(R.id.tv_acquire_imediately)

    }


    //#############################埋点################################
    /**
     * 卡片曝光埋点事件
     */
    private fun showCardEV() {
        LogHelper.addEV("/jianzhi/message/im_qzgw", "/jianzhi/message/im_qzgw@atype=click@ca_name=doumi@ca_source=app@ca_from=vip_get")
    }


}